(* reorder/reorder-parse.sml *)

functor ReorderParseFn(structure Parse : PARSE
		       structure Reorder : REORDER
		       structure Control : CONTROL
		       sharing Parse.Absyn = Reorder.Absyn
			 ) : PARSE =
  struct

    structure Absyn = Parse.Absyn

    fun parseInterface file =
      let val module = Parse.parseInterface file
      in
	if !Control.doReorder then
	  let val Absyn.MODULE(interface,_) = module
	  in
	    Absyn.MODULE(Reorder.reorderInterface interface, [])
	  end
	else module
      end

    fun parseModule file =
      let val module = Parse.parseModule file
      in
	if !Control.doReorder then Reorder.reorderModule module
	else module
      end

  end (* functor ReorderParseFn *)
