#!/bin/sh
# Determine how to invoke SML/NJ's compilation manager.

#set -x
SMLCM=$1

echo 'let val _ = CM.autoload "$smlnj/cm/full.cm" in OS.Process.exit OS.Process.failure end;' | $SMLCM > /dev/null 2>&1
if [ $? -eq 1 ]; then
    # 110.29 or newer
    CMINIT=''
    CMMAKE='CM.make "sources.cm"'
    CMRESET='CM.State.reset()'
else
echo 'let val f = fn _ => CM.make() in OS.Process.exit OS.Process.failure end' | $SMLCM > /dev/null 2>&1
if [ $? -eq 1 ]; then
    # 110.17 or older
    CMINIT=''
    CMMAKE='CM.make()'
    CMRESET='CM.clear()'
else
    echo Failed to determine how to invoke CM
    exit 1
fi
fi

echo "${CMINIT}"
echo "val _ = ${CMMAKE};"
echo "val _ = ${CMRESET};"
echo 'val _ = SysDep.exportFn("rml", Start.start Main.main);'

exit 0
